module Address
  Country = {
    "Belgium"=>"+32", "Belize"=>"",
    "Germany"=>"", "Guatemala"=>"",
    "Iceland"=>"",
    "Mexico"=>"",
    "Netherlands"=>"00+31", "Norway"=>"",
    "Poland"=>"+48",
    "Sweden"=>"",
    "United Kingdom"=>"+49", "USA"=>"00+1"
  }

  class Anon
    include XmlElt
    def initialize()
      @attrib = Hash.new
      @content = ""  # small hack
    end
    def addAttribute(name, value=nil)
      @attrib[name] = value  if value != ""
    end
    def method_missing(symbol, *param)
      name = "#{symbol.to_s()}"
      if name[-1,1] == "="
	@attrib[name[0...-1]] = param[0]
	return param[0]
      elsif @attrib.has_key? name
	return @attrib[name]
      else
	return ""
      end
    end
  end

  class Location < Anon
    def initialize(name)
      super()
      @name = name  # like, home, work...
    end
    attr_reader :name, :attrib
    def openingTagStr(level=0)
      indentStr(level)+"<"+@name+attribStr+">"
    end
    def closingTagStr(level=0)
      indentStr(level)+"</"+@name+">"
    end
  end

  class Person < Anon
    def Person::xmlName() "person" end
    def initialize
      @attrib = {}
      @locs = {}
    end
    attr_reader :attrib, :locs
    def addChild(loc)
      p "Adding #{loc}"  if $DEBUG
      @locs[loc.name] = loc  unless @locs.has_key? loc.name
    end
    def contentStr(level)
      result = ""
      @locs.each_value do |content|
	result += content.to_s(level+1)
      end
      result
    end
    def method_missing(symbol, *arg)
      name = symbol.to_s
      return @locs[name]  if @locs.has_key? name
      super
    end
    def match(re)
      re =~ name
    end
  end
end
