require 'pim/address/book'
require 'wise'

require 'pim/common/all'

require 'pim/gsm'

module Wise
  class LocEdit < HashEdit
    @@call = proc { |hashline|
      cellphone = Gsm::Chat.new()
      cellphone.call(hashline.value)
      cellphone.finalize()
    }
    @@email = proc { Dialog.new(nil, :modal=>@root, :text=>"Can not send e-mail, yet") }

    def initialize(parent, settings={})
      super(parent, {
	:attop=>["phone", "mobile", "email", "address", "code", "city"],
	:action=>{"phone"=>["Call", @@call], "mobile"=>["Call", @@call]}
      }.update(settings))
    end

    AllEdits = {}
    def LocEdit::get(parent, settings={})
      loc_edit = AllEdits[settings[:title]]
      if loc_edit
	parent.insert_child(loc_edit)
	loc_edit.hash = settings[:hash]
      else
	loc_edit = LocEdit.new(parent, settings)
	### Not for now, must not call empty! or don't do destroy there...
	### Prolly need to write a free+XDestroy finalize for native windows...
	# AllEdits[settings[:title]] = loc_edit
      end
    end
  end

  class PersonEdit < Window

    def initialize(parent, settings={})
      super(parent, {:layout=>VLayout}.update(settings))
      @he = HashEdit.new(self, :hash=>settings[:person].attrib, :attop=>["name"])
      @add_loc = HList.new(self)
      @loc_name = Input.new(@add_loc, :chars=>20)
      Button.new(@add_loc, :text=>"Add Location") {
	if @loc_name.text != ""
remap = @holder.toplevel.mapped?  # sorry...
@holder.toplevel.unmap  if remap
	  loc = Address::Location.new(@loc_name.text)
	  @person.addChild(loc)
	  LocEdit.get(@holder, :title=>@loc_name.text, :hash=>loc.attrib)
@holder.toplevel.map  if remap
	  @loc_name.text = ""
	end
      }
      @holder = Tabbed.new(self, :del_callback=>proc { |name|
	@person.locs.delete(name)
      })
      set(settings[:person])
    end

    def set(new_person)
      @person = new_person
remap = toplevel.mapped?  # sorry...
toplevel.unmap  if remap
      @holder.empty!
      @he.hash = new_person.attrib
      @person.locs.each { |name, loc|
	LocEdit.get(@holder, :title=>loc.name, :hash=>loc.attrib)
      }
toplevel.map  if remap
    end
  end

  begin
    @root = Window.new(nil, :title=>"Ruby-pim: AddressBook", :map=>false,
		       :font=>Wise::Font.new("snap"))

    $address.addChild(Address::Person.new())  if $address.person.size == 0
    index = 0
    @table = $address.person
    pe = PersonEdit.new(@root, :person=>@table[index])

    w = HList.new(@root)
    Button.new(w, :text=>"Add Person") {
      $address.addChild(Address::Person.new())
      index = @table.size - 1
      pe.set(@table[index])
    }
    Button.new(w, :text=>"Prev") {
      index -= 1
      index = @table.size - 1  if index < 0
      pe.set(@table[index])
    }
    Button.new(w, :text=>"Search") {
      fghid = InputDialog.new(nil, :modal=>@root, :text=>"Search RegExp:", :map=>false) {
	p "Looking for `#{fghid.input}'"  if $DEBUG
	@table = $address.match(Regexp.new(fghid.input, Regexp::IGNORECASE))
	index = 0
	pe.set(@table[index])
	fghid.destroy
      }
      fghid.map
    }
    Button.new(w, :text=>"Next") {
      index += 1
      index = 0  if index == @table.size
      pe.set(@table[index])
    }
    Button.new(w, :text=>"Save Book") {
      $address.save_book()  # table.save ???
    }

    @root.map

    Serialize::serialize()

    $address.save_book()
  #rescue
    #p $!
    # retry
  end
end
