require 'wise'

module Wise
  class HashLine < HList
    def initialize(parent, settings={})
      @name = settings.delete(:name)
      @value = settings.delete(:value)
      super(parent, settings.dup)
      settings.delete(:index)
      Label.new(self, {:text=>@name}.update(settings))
      se = StringEdit.new(self, {:string=>@value, :chars=>20}.update(settings))
      if settings.has_key?(:action)
	action = settings[:action]
	@w = Button.new(self, :fg=>Color.new(200, 50, 50), :text=>action[0]) {
	  action[1].call(self)
	}
      end
    end
    attr_reader :name, :value
  end

  class HashEdit < VList
    @@del = proc { |hashline|
      hashline.parent.hash.delete(hashline.name)
      hashline.parent.delete_child(hashline)
    }
    def initialize(parent, settings={})
      @at_top = settings.delete :attop
      @action = (settings.delete :action) || {}
      super(parent, @sett_dup = {}.update(settings))
      self.hash = settings.delete :hash
    end

    def hash=(new_hash)
      @hash = new_hash
      self.empty!
      @at_top.each { |name|
	@hash[name] = ""  unless @hash[name]
	if @action.has_key? name
	  HashLine.new(self, :name=>name, :value=>@hash[name],
		       :action=>@action[name])
	else
	  HashLine.new(self, :name=>name, :value=>@hash[name])
	end
      }
      @hash.each_pair { |name, value|
	unless @at_top.include? name
	  HashLine.new(self, :name=>name, :value=>value, :action=>["Del", @@del])
	end
      }
      @add_entry = HList.new(self, {}.update(@sett_dup))
      @name_f = Input.new(@add_entry, {:chars=>10}.update(@sett_dup))
      @value = Input.new(@add_entry, {:chars=>20}.update(@sett_dup))
      Button.new(@add_entry, {:text=>"Add"}.update(@sett_dup)) {
	if @name_f.text != ""
	  @hash[@name_f.text] = @value.text
	  HashLine.new(self, {:name=>@name_f.text, :value=>@value.text, :index=>-1, :action=>["Del", @@del]}.update(@sett_dup))
	  @name_f.text = ""
	  @value.text = ""
	end
      }
    end
    attr_reader :hash, :at_top
  end
end
